(get-info :version) ;; (:version "4.8.5 - build hashcode 064c9faf116b")

(set-option :auto_config false)
(set-option :smt.mbqi false)
; (set-option :smt.arith.random_initial_value true)
; (set-option :smt.qi.profile true)
; (set-option :smt.qi.profile_freq 100000)

(declare-datatypes () ((Snap (unit) (pair (fst Snap) (snd Snap)))))

(declare-fun intToSnap (Int) Snap)
(declare-fun snapToInt (Snap) Int)
(assert (forall ((x Int)) (!
  (= x (snapToInt(intToSnap x)))
  :pattern ((intToSnap x))
)))

(declare-fun safe_mult_i32 (Int Int) Bool)

(define-const MIN_i32 Int -2147483648)
(define-const MAX_i32 Int 2147483647)
(define-const MIN_i64 Int -9223372036854775808)
(define-const MAX_i64 Int 9223372036854775807)

(assert (forall ((x Int) (y Int)) (!
  (implies
    (and
      (and (<= MIN_i32 x) (<= x MAX_i32))
      (and (<= MIN_i32 y) (<= y MAX_i32)))
    (=
      (safe_mult_i32 x y)
      (implies
        (and (<= MIN_i64 (* x y)) (<= (* x y) MAX_i64))
        (and (<= MIN_i32 (* x y)) (<= (* x y) MAX_i32)))))
  :pattern ((safe_mult_i32 x y)))))

(check-sat)

(declare-const i Int)
;; Even replacing the next two assertions by a single assert with a conjunction
;; makes Z3 terminate immediately
(assert (<= MIN_i32 i))
(assert (<= i MAX_i32))

(declare-const s1 Snap)
(declare-const s2 Snap)
(assert (= s1 (pair (intToSnap i) s2)))

(check-sat)

(assert (safe_mult_i32 i i))
; (assert (<= MIN_i32 (* i i))) ;; Apparently not relevant for observed performance

(assert (not (<= (* i i) MAX_i32)))
(set-option :timeout 50000)
(check-sat)

(get-info :all-statistics)
